/* Copyright 2020-2022, Michele Santullo
 * This file is part of wrenpp.
 *
 * Wrenpp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Wrenpp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with wrenpp.  If not, see <http://www.gnu.org/licenses/>.
 */

#as --march=generic64 -o dynafunc.o ~/dev/code/cpp/wrentest/src/dynafunc.asm
#objcopy -j .text -O binary dynafunc.o dynafunc.bin
#xxd -i dynafunc.bin

.global g_dynafunc
.global g_dynafunc_end

g_dynafunc:
	//VM pointer, parameter 1
	movabsq $0xdeadbeefdeadbeef, %rdi
	//ModuleAndName string part, parameter 2
	movabsq $0x1badb0021badb002, %rsi
	//ModuleAndName data part, parameter 3
	movabsq $0xfee1deadfee1dead, %rdx

	//jump address
	movabsq $0xbadc0ffee0ddf00d, %rax
	jmp *%rax
	ret
g_dynafunc_end:
